// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_incoming_connections.sql

package queries

import (
	"context"

	"github.com/jackc/pgx/v5/pgtype"
)

const listIncomingConnections = `-- name: ListIncomingConnections :many

SELECT
    p.service_peer_id,
    p.service_name,
    p.content_hash,
    c.created_at,
    c.valid_not_after,
    c.valid_not_before,
    c.state,
    p.hash,
    p.service_publication_delegator_peer_id,
    p.delegator_peer_id,
    p.outway_peer_id
FROM (
         SELECT outway_peer_id, service_peer_id, service_name, content_hash, hash, service_publication_delegator_peer_id, null as delegator_peer_id
         FROM contracts.grants_service_connection
         WHERE service_peer_id = $2::text
         UNION DISTINCT
         SELECT outway_peer_id,service_peer_id, service_name, content_hash, hash, service_publication_delegator_peer_id, delegator_peer_id as delegator_peer_id
         FROM contracts.grants_delegated_service_connection
         WHERE service_peer_id = $2::text
     ) AS p
         JOIN contracts.contracts_with_state AS c ON c.hash = p.content_hash
WHERE
    CASE
        when cardinality($3::text[]) = 0 THEN
            content_hash IN (SELECT hash AS content_hash FROM contracts.contracts_with_state)
        else
            content_hash IN (SELECT hash AS content_hash FROM contracts.contracts_with_state where contracts_with_state.state = ANY ($3::text[]))
        end
  AND
    ($4::timestamp is NULL AND $5::text = '')
   OR (
    $6::text = 'asc'
            AND
            (c.created_at >= $4::timestamp AND (c.created_at > $4::timestamp OR p.hash > $5::text)
        )
        OR (
            $6::text = 'desc'
            AND
            (c.created_at <= $4::timestamp AND (c.created_at < $4::timestamp OR p.hash < $5::text))
        )
    )
ORDER BY
CASE
    WHEN $6::text = 'asc' THEN  (c.created_at, p.hash COLLATE "C") END ASC,
CASE
    WHEN $6::text = 'desc' THEN (c.created_at, p.hash COLLATE "C") END DESC
LIMIT $1
`

type ListIncomingConnectionsParams struct {
	Limit               int32
	SelfPeerID          string
	ContractStates      []string
	PaginationCreatedAt pgtype.Timestamp
	PaginationGrantHash string
	OrderDirection      string
}

type ListIncomingConnectionsRow struct {
	ServicePeerID                     string
	ServiceName                       string
	ContentHash                       string
	CreatedAt                         pgtype.Timestamptz
	ValidNotAfter                     pgtype.Timestamptz
	ValidNotBefore                    pgtype.Timestamptz
	State                             interface{}
	Hash                              string
	ServicePublicationDelegatorPeerID pgtype.Text
	DelegatorPeerID                   interface{}
	OutwayPeerID                      string
}

// Copyright © VNG Realisatie 2024
// Licensed under the EUPL
// NOTE: unable to use ASC/DESC dynamically so we use a switch case
func (q *Queries) ListIncomingConnections(ctx context.Context, arg *ListIncomingConnectionsParams) ([]*ListIncomingConnectionsRow, error) {
	rows, err := q.db.Query(ctx, listIncomingConnections,
		arg.Limit,
		arg.SelfPeerID,
		arg.ContractStates,
		arg.PaginationCreatedAt,
		arg.PaginationGrantHash,
		arg.OrderDirection,
	)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListIncomingConnectionsRow{}
	for rows.Next() {
		var i ListIncomingConnectionsRow
		if err := rows.Scan(
			&i.ServicePeerID,
			&i.ServiceName,
			&i.ContentHash,
			&i.CreatedAt,
			&i.ValidNotAfter,
			&i.ValidNotBefore,
			&i.State,
			&i.Hash,
			&i.ServicePublicationDelegatorPeerID,
			&i.DelegatorPeerID,
			&i.OutwayPeerID,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listIncomingConnectionsForServices = `-- name: ListIncomingConnectionsForServices :many
SELECT
    p.service_peer_id,
    p.service_name,
    p.content_hash,
    c.created_at,
    c.valid_not_after,
    c.valid_not_before,
    c.state,
    p.hash,
    p.service_publication_delegator_peer_id,
    p.delegator_peer_id,
    p.outway_peer_id
FROM (
         SELECT outway_peer_id, service_peer_id, service_name, content_hash, hash, service_publication_delegator_peer_id, null as delegator_peer_id
         FROM contracts.grants_service_connection
         WHERE service_peer_id = $1::text
         UNION DISTINCT
         SELECT outway_peer_id,service_peer_id, service_name, content_hash, hash, service_publication_delegator_peer_id, delegator_peer_id as delegator_peer_id
         FROM contracts.grants_delegated_service_connection
         WHERE service_peer_id = $1::text
     ) AS p
         JOIN contracts.contracts_with_state AS c ON c.hash = p.content_hash
WHERE
    CASE
        when cardinality($2::text[]) = 0 THEN
            content_hash IN (SELECT hash AS content_hash FROM contracts.contracts_with_state)
        else
            content_hash IN (SELECT hash AS content_hash FROM contracts.contracts_with_state where contracts_with_state.state = ANY ($2::text[]))
        end
  AND
   p.service_name = ANY($3::varchar[])
ORDER BY
CASE
    WHEN $4::text = 'asc' THEN  (c.created_at, p.hash COLLATE "C") END ASC,
CASE
    WHEN $4::text = 'desc' THEN (c.created_at, p.hash COLLATE "C") END DESC
`

type ListIncomingConnectionsForServicesParams struct {
	SelfPeerID     string
	ContractStates []string
	ServiceNames   []string
	OrderDirection string
}

type ListIncomingConnectionsForServicesRow struct {
	ServicePeerID                     string
	ServiceName                       string
	ContentHash                       string
	CreatedAt                         pgtype.Timestamptz
	ValidNotAfter                     pgtype.Timestamptz
	ValidNotBefore                    pgtype.Timestamptz
	State                             interface{}
	Hash                              string
	ServicePublicationDelegatorPeerID pgtype.Text
	DelegatorPeerID                   interface{}
	OutwayPeerID                      string
}

// NOTE: unable to use ASC/DESC dynamically so we use a switch case
func (q *Queries) ListIncomingConnectionsForServices(ctx context.Context, arg *ListIncomingConnectionsForServicesParams) ([]*ListIncomingConnectionsForServicesRow, error) {
	rows, err := q.db.Query(ctx, listIncomingConnectionsForServices,
		arg.SelfPeerID,
		arg.ContractStates,
		arg.ServiceNames,
		arg.OrderDirection,
	)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListIncomingConnectionsForServicesRow{}
	for rows.Next() {
		var i ListIncomingConnectionsForServicesRow
		if err := rows.Scan(
			&i.ServicePeerID,
			&i.ServiceName,
			&i.ContentHash,
			&i.CreatedAt,
			&i.ValidNotAfter,
			&i.ValidNotBefore,
			&i.State,
			&i.Hash,
			&i.ServicePublicationDelegatorPeerID,
			&i.DelegatorPeerID,
			&i.OutwayPeerID,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
